searchNodes=[{"ref":"Mix.Tasks.Sobelow.html","title":"Mix.Tasks.Sobelow","type":"task","doc":"Sobelow is a static analysis tool for discovering vulnerabilities in Phoenix applications. This tool should be run in the root of the project directory with the following command: mix sobelow Command line options --root -r - Specify application root directory --verbose -v - Print vulnerable code snippets --ignore -i - Ignore modules --ignore-files - Ignore files --details -d - Get module details --all-details - Get all module details --private - Skip update checks --mark-skip-all - Mark all printed findings as skippable --clear-skip - Clear configuration added by --mark-skip-all --skip - Skip functions flagged with #sobelow_skip or tagged with --mark-skip-all --router - Specify router location --exit - Return non-zero exit status --threshold - Only return findings at or above a given confidence level --format - Specify findings output format --quiet - Return no output if there are no findings --compact - Minimal, single-line findings --save-config - Generates a configuration file based on command line options --config - Run Sobelow with configuration file Ignoring modules If specific modules, or classes of modules are not relevant to the scan, it is possible to ignore them with a comma-separated list. mix sobelow -i XSS.Raw,Traversal Supported modules XSS XSS.Raw XSS.SendResp XSS.ContentType XSS.HTML SQL SQL.Query SQL.Stream Config Config.CSRF Config.Headers Config.CSP Config.HTTPS Config.HSTS Config.Secrets Config.CSWH Vuln Vuln.CookieRCE Vuln.HeaderInject Vuln.PlugNull Vuln.Redirect Vuln.Coherence Vuln.Ecto Traversal Traversal.SendFile Traversal.FileModule Traversal.SendDownload Misc Misc.BinToTerm Misc.FilePath RCE.EEx RCE.CodeModule CI CI.System CI.OS DOS DOS.StringToAtom DOS.ListToAtom DOS.BinToAtom"},{"ref":"Mix.Tasks.Sobelow.html#run/1","title":"Mix.Tasks.Sobelow.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Sobelow.html#run_diff/1","title":"Mix.Tasks.Sobelow.run_diff/1","type":"function","doc":""},{"ref":"Mix.Tasks.Sobelow.html#set_env/2","title":"Mix.Tasks.Sobelow.set_env/2","type":"function","doc":""},{"ref":"Sobelow.html","title":"Sobelow","type":"module","doc":"Sobelow is a static analysis tool for discovering vulnerabilities in Phoenix applications."},{"ref":"Sobelow.html#all_details/0","title":"Sobelow.all_details/0","type":"function","doc":""},{"ref":"Sobelow.html#details/0","title":"Sobelow.details/0","type":"function","doc":""},{"ref":"Sobelow.html#format/0","title":"Sobelow.format/0","type":"function","doc":""},{"ref":"Sobelow.html#get_env/1","title":"Sobelow.get_env/1","type":"function","doc":""},{"ref":"Sobelow.html#get_ignored/0","title":"Sobelow.get_ignored/0","type":"function","doc":""},{"ref":"Sobelow.html#get_mod/1","title":"Sobelow.get_mod/1","type":"function","doc":""},{"ref":"Sobelow.html#is_vuln?/1","title":"Sobelow.is_vuln?/1","type":"function","doc":""},{"ref":"Sobelow.html#log_finding/1","title":"Sobelow.log_finding/1","type":"function","doc":""},{"ref":"Sobelow.html#log_finding/2","title":"Sobelow.log_finding/2","type":"function","doc":""},{"ref":"Sobelow.html#loggable?/2","title":"Sobelow.loggable?/2","type":"function","doc":""},{"ref":"Sobelow.html#meets_threshold?/1","title":"Sobelow.meets_threshold?/1","type":"function","doc":""},{"ref":"Sobelow.html#run/0","title":"Sobelow.run/0","type":"function","doc":""},{"ref":"Sobelow.html#save_config/1","title":"Sobelow.save_config/1","type":"function","doc":""},{"ref":"Sobelow.CI.html","title":"Sobelow.CI","type":"module","doc":"Command Injection Command Injection vulnerabilities are a result of passing untrusted input to an operating system shell, and may result in complete system compromise. Read more about Command Injection here: https://www.owasp.org/index.php/Command_Injection Command Injection checks can be ignored with the following command: $ mix sobelow -i CI"},{"ref":"Sobelow.CI.html#details/0","title":"Sobelow.CI.details/0","type":"function","doc":""},{"ref":"Sobelow.CI.html#get_vulns/4","title":"Sobelow.CI.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.CI.OS.html","title":"Sobelow.CI.OS","type":"module","doc":""},{"ref":"Sobelow.CI.OS.html#details/0","title":"Sobelow.CI.OS.details/0","type":"function","doc":""},{"ref":"Sobelow.CI.OS.html#parse_def/1","title":"Sobelow.CI.OS.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.CI.OS.html#run/2","title":"Sobelow.CI.OS.run/2","type":"function","doc":""},{"ref":"Sobelow.CI.System.html","title":"Sobelow.CI.System","type":"module","doc":""},{"ref":"Sobelow.CI.System.html#details/0","title":"Sobelow.CI.System.details/0","type":"function","doc":""},{"ref":"Sobelow.CI.System.html#parse_def/1","title":"Sobelow.CI.System.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.CI.System.html#run/2","title":"Sobelow.CI.System.run/2","type":"function","doc":""},{"ref":"Sobelow.Config.html","title":"Sobelow.Config","type":"module","doc":""},{"ref":"Sobelow.Config.html#details/0","title":"Sobelow.Config.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.html#fetch/3","title":"Sobelow.Config.fetch/3","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_configs/2","title":"Sobelow.Config.get_configs/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_configs_by_file/2","title":"Sobelow.Config.get_configs_by_file/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_fuzzy_configs/2","title":"Sobelow.Config.get_fuzzy_configs/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_pipelines/1","title":"Sobelow.Config.get_pipelines/1","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_plug_accepts/1","title":"Sobelow.Config.get_plug_accepts/1","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_plug_list/1","title":"Sobelow.Config.get_plug_list/1","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_version/1","title":"Sobelow.Config.get_version/1","type":"function","doc":""},{"ref":"Sobelow.Config.html#get_version/2","title":"Sobelow.Config.get_version/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#is_plug?/2","title":"Sobelow.Config.is_plug?/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#is_vuln_pipeline?/2","title":"Sobelow.Config.is_vuln_pipeline?/2","type":"function","doc":""},{"ref":"Sobelow.Config.html#parse_accepts/1","title":"Sobelow.Config.parse_accepts/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSP.html","title":"Sobelow.Config.CSP","type":"module","doc":"Missing Content-Security-Policy Content-Security-Policy is an HTTP header that helps mitigate a number of attacks, including Cross-Site Scripting. Read more about CSP here: https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP Missing Content-Security-Policy is flagged by sobelow when a pipeline implements the :put_secure_browser_headers plug, but does not provide a Content-Security-Policy header in the custom headers map. When it comes to CSP, just about any policy is better than none. If you are unsure about which policy to use, the following mitigates most typical XSS vectors: plug :put_secure_browser_headers, %{&quot;content-security-policy&quot; =&gt; &quot;default-src &#39;self&#39;&quot;} Documentation on the put_secure_browser_headers plug function can be found here: https://hexdocs.pm/phoenix/Phoenix.Controller.html#put_secure_browser_headers/2 Content-Security-Policy checks can be ignored with the following command: $ mix sobelow -i Config.CSP"},{"ref":"Sobelow.Config.CSP.html#check_vuln_pipeline/2","title":"Sobelow.Config.CSP.check_vuln_pipeline/2","type":"function","doc":""},{"ref":"Sobelow.Config.CSP.html#details/0","title":"Sobelow.Config.CSP.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.CSP.html#run/1","title":"Sobelow.Config.CSP.run/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSRF.html","title":"Sobelow.Config.CSRF","type":"module","doc":"Cross-Site Request Forgery In a Cross-Site Request Forgery (CSRF) attack, an untrusted application can cause a user&#39;s browser to submit requests or perform actions on the user&#39;s behalf. Read more about CSRF here: https://owasp.org/www-community/attacks/csrf Cross-Site Request Forgery is flagged by sobelow when a pipeline fetches a session, but does not implement the :protect_from_forgery plug. CSRF checks can be ignored with the following command: $ mix sobelow -i Config.CSRF"},{"ref":"Sobelow.Config.CSRF.html#details/0","title":"Sobelow.Config.CSRF.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.CSRF.html#run/1","title":"Sobelow.Config.CSRF.run/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSRFRoute.html","title":"Sobelow.Config.CSRFRoute","type":"module","doc":"Cross-Site Request Forgery In a Cross-Site Request Forgery (CSRF) attack, an untrusted application can cause a user&#39;s browser to submit requests or perform actions on the user&#39;s behalf. Read more about CSRF here: https://www.owasp.org/index.php/Cross-SiteRequest_Forgery(CSRF) This type of CSRF is flagged by sobelow when state-changing routes share an action with GET-based routes. For example: get &quot;/users&quot;, UserController, :new post &quot;/users&quot;, UserController, :new In this instance, it may be possible to trigger the POST functionality with a GET request and query parameters. CSRF checks can be ignored with the following command: $ mix sobelow -i Config.CSRFRoute"},{"ref":"Sobelow.Config.CSRFRoute.html#combine_scopes/1","title":"Sobelow.Config.CSRFRoute.combine_scopes/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSRFRoute.html#details/0","title":"Sobelow.Config.CSRFRoute.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.CSRFRoute.html#route_findings/2","title":"Sobelow.Config.CSRFRoute.route_findings/2","type":"function","doc":""},{"ref":"Sobelow.Config.CSRFRoute.html#run/1","title":"Sobelow.Config.CSRFRoute.run/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSWH.html","title":"Sobelow.Config.CSWH","type":"module","doc":"Cross-Site Websocket Hijacking Websocket connections are not bound by the same-origin policy. Connections that do not validate the origin may leak information to an attacker. More information can be found here: https://www.christian-schneider.net/CrossSiteWebSocketHijacking.html Cross-Site Websocket Hijacking checks can be disabled with the following command: $ mix sobelow -i Config.CSWH"},{"ref":"Sobelow.Config.CSWH.html#check_socket/1","title":"Sobelow.Config.CSWH.check_socket/1","type":"function","doc":""},{"ref":"Sobelow.Config.CSWH.html#details/0","title":"Sobelow.Config.CSWH.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.CSWH.html#run/1","title":"Sobelow.Config.CSWH.run/1","type":"function","doc":""},{"ref":"Sobelow.Config.HSTS.html","title":"Sobelow.Config.HSTS","type":"module","doc":"HSTS The HTTP Strict Transport Security (HSTS) header helps defend against man-in-the-middle attacks by preventing unencrypted connections. HSTS checks can be ignored with the following command: $ mix sobelow -i Config.HSTS"},{"ref":"Sobelow.Config.HSTS.html#details/0","title":"Sobelow.Config.HSTS.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.HSTS.html#run/2","title":"Sobelow.Config.HSTS.run/2","type":"function","doc":""},{"ref":"Sobelow.Config.HTTPS.html","title":"Sobelow.Config.HTTPS","type":"module","doc":"HTTPS Without HTTPS, attackers in a priveleged network position can intercept and modify traffic. Sobelow detects missing HTTPS by checking the prod configuration. HTTPS checks can be ignored with the following command: $ mix sobelow -i Config.HTTPS"},{"ref":"Sobelow.Config.HTTPS.html#details/0","title":"Sobelow.Config.HTTPS.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.HTTPS.html#run/2","title":"Sobelow.Config.HTTPS.run/2","type":"function","doc":""},{"ref":"Sobelow.Config.Headers.html","title":"Sobelow.Config.Headers","type":"module","doc":"Missing Secure HTTP Headers By default, Phoenix HTTP responses contain a number of secure HTTP headers that attempt to mitigate XSS, click-jacking, and content-sniffing attacks. Missing Secure HTTP Headers is flagged by sobelow when a pipeline accepts &quot;html&quot; requests, but does not implement the :put_secure_browser_headers plug. Secure Headers checks can be ignored with the following command: $ mix sobelow -i Config.Headers"},{"ref":"Sobelow.Config.Headers.html#details/0","title":"Sobelow.Config.Headers.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.Headers.html#run/1","title":"Sobelow.Config.Headers.run/1","type":"function","doc":""},{"ref":"Sobelow.Config.Secrets.html","title":"Sobelow.Config.Secrets","type":"module","doc":"Hard-coded Secrets In the event of a source-code disclosure via file read vulnerability, accidental commit, etc, hard-coded secrets may be exposed to an attacker. This may result in database access, cookie forgery, and other issues. Sobelow detects missing hard-coded secrets by checking the prod configuration. Hard-coded secrets checks can be ignored with the following command: $ mix sobelow -i Config.Secrets"},{"ref":"Sobelow.Config.Secrets.html#details/0","title":"Sobelow.Config.Secrets.details/0","type":"function","doc":""},{"ref":"Sobelow.Config.Secrets.html#is_env_var?/1","title":"Sobelow.Config.Secrets.is_env_var?/1","type":"function","doc":""},{"ref":"Sobelow.Config.Secrets.html#run/2","title":"Sobelow.Config.Secrets.run/2","type":"function","doc":""},{"ref":"Sobelow.DOS.html","title":"Sobelow.DOS","type":"module","doc":""},{"ref":"Sobelow.DOS.html#details/0","title":"Sobelow.DOS.details/0","type":"function","doc":""},{"ref":"Sobelow.DOS.html#get_vulns/4","title":"Sobelow.DOS.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.DOS.BinToAtom.html","title":"Sobelow.DOS.BinToAtom","type":"module","doc":"Denial of Service via Unsafe Atom Interpolation In Elixir, atoms are not garbage collected. As such, if user input is used to create atoms (as in :&quot;foo\#{bar}&quot;, or in :erlang.binary_to_atom), it may result in memory exhaustion. Prefer the String.to_existing_atom function for untrusted user input. Atom interpolation checks can be ignored with the following command: $ mix sobelow -i DOS.BinToAtom"},{"ref":"Sobelow.DOS.BinToAtom.html#details/0","title":"Sobelow.DOS.BinToAtom.details/0","type":"function","doc":""},{"ref":"Sobelow.DOS.BinToAtom.html#parse_def/1","title":"Sobelow.DOS.BinToAtom.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.DOS.BinToAtom.html#run/2","title":"Sobelow.DOS.BinToAtom.run/2","type":"function","doc":""},{"ref":"Sobelow.DOS.ListToAtom.html","title":"Sobelow.DOS.ListToAtom","type":"module","doc":"Denial of Service via List.to_atom In Elixir, atoms are not garbage collected. As such, if user input is passed to the List.to_atom function, it may result in memory exhaustion. Prefer the List.to_existing_atom function for untrusted user input. List.to_atom checks can be ignored with the following command: $ mix sobelow -i DOS.ListToAtom"},{"ref":"Sobelow.DOS.ListToAtom.html#details/0","title":"Sobelow.DOS.ListToAtom.details/0","type":"function","doc":""},{"ref":"Sobelow.DOS.ListToAtom.html#parse_def/1","title":"Sobelow.DOS.ListToAtom.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.DOS.ListToAtom.html#run/2","title":"Sobelow.DOS.ListToAtom.run/2","type":"function","doc":""},{"ref":"Sobelow.DOS.StringToAtom.html","title":"Sobelow.DOS.StringToAtom","type":"module","doc":"Denial of Service via String.to_atom In Elixir, atoms are not garbage collected. As such, if user input is passed to the String.to_atom function, it may result in memory exhaustion. Prefer the String.to_existing_atom function for untrusted user input. String.to_atom checks can be ignored with the following command: $ mix sobelow -i DOS.StringToAtom"},{"ref":"Sobelow.DOS.StringToAtom.html#details/0","title":"Sobelow.DOS.StringToAtom.details/0","type":"function","doc":""},{"ref":"Sobelow.DOS.StringToAtom.html#parse_def/1","title":"Sobelow.DOS.StringToAtom.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.DOS.StringToAtom.html#run/2","title":"Sobelow.DOS.StringToAtom.run/2","type":"function","doc":""},{"ref":"Sobelow.Finding.html","title":"Sobelow.Finding","type":"module","doc":""},{"ref":"Sobelow.Finding.html#fetch_fingerprint/1","title":"Sobelow.Finding.fetch_fingerprint/1","type":"function","doc":""},{"ref":"Sobelow.Finding.html#fingerprint/1","title":"Sobelow.Finding.fingerprint/1","type":"function","doc":""},{"ref":"Sobelow.Finding.html#init/3","title":"Sobelow.Finding.init/3","type":"function","doc":""},{"ref":"Sobelow.Finding.html#multi_from_def/3","title":"Sobelow.Finding.multi_from_def/3","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html","title":"Sobelow.FindingLog","type":"module","doc":""},{"ref":"Sobelow.FindingLog.html#add/2","title":"Sobelow.FindingLog.add/2","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html#child_spec/1","title":"Sobelow.FindingLog.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Sobelow.FindingLog.html#format_json/2","title":"Sobelow.FindingLog.format_json/2","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html#init/1","title":"Sobelow.FindingLog.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Sobelow.FindingLog.html#json/1","title":"Sobelow.FindingLog.json/1","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html#log/0","title":"Sobelow.FindingLog.log/0","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html#quiet/0","title":"Sobelow.FindingLog.quiet/0","type":"function","doc":""},{"ref":"Sobelow.FindingLog.html#start_link/0","title":"Sobelow.FindingLog.start_link/0","type":"function","doc":""},{"ref":"Sobelow.FindingType.html","title":"Sobelow.FindingType","type":"module","doc":""},{"ref":"Sobelow.MetaLog.html","title":"Sobelow.MetaLog","type":"module","doc":""},{"ref":"Sobelow.MetaLog.html#add_templates/1","title":"Sobelow.MetaLog.add_templates/1","type":"function","doc":""},{"ref":"Sobelow.MetaLog.html#child_spec/1","title":"Sobelow.MetaLog.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Sobelow.MetaLog.html#delete_raw/2","title":"Sobelow.MetaLog.delete_raw/2","type":"function","doc":""},{"ref":"Sobelow.MetaLog.html#get_templates/0","title":"Sobelow.MetaLog.get_templates/0","type":"function","doc":""},{"ref":"Sobelow.MetaLog.html#init/1","title":"Sobelow.MetaLog.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Sobelow.MetaLog.html#start_link/0","title":"Sobelow.MetaLog.start_link/0","type":"function","doc":""},{"ref":"Sobelow.Misc.html","title":"Sobelow.Misc","type":"module","doc":""},{"ref":"Sobelow.Misc.html#details/0","title":"Sobelow.Misc.details/0","type":"function","doc":""},{"ref":"Sobelow.Misc.html#get_vulns/4","title":"Sobelow.Misc.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.Misc.BinToTerm.html","title":"Sobelow.Misc.BinToTerm","type":"module","doc":"Insecure use of binary_to_term If user input is passed to Erlang&#39;s binary_to_term function it may result in memory exhaustion or code execution. Even with the :safe option, binary_to_term will deserialize functions, and shouldn&#39;t be considered safe to use with untrusted input. binary_to_term checks can be ignored with the following command: $ mix sobelow -i Misc.BinToTerm"},{"ref":"Sobelow.Misc.BinToTerm.html#details/0","title":"Sobelow.Misc.BinToTerm.details/0","type":"function","doc":""},{"ref":"Sobelow.Misc.BinToTerm.html#parse_def/1","title":"Sobelow.Misc.BinToTerm.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.Misc.BinToTerm.html#run/2","title":"Sobelow.Misc.BinToTerm.run/2","type":"function","doc":""},{"ref":"Sobelow.Misc.FilePath.html","title":"Sobelow.Misc.FilePath","type":"module","doc":"Insecure use of File and Path Note: This check has been deprecated. File/Path issues were addressed with the release of OTP 21. In Elixir, File methods are null-terminated, while Path functions are not. This may cause security issues in certain situations. For example: user_input = &quot;/var/www/secret.txt\\0/name&quot; path = Path.dirname(user_input) public_file = path &lt;&gt; &quot;/public.txt&quot; File.read(public_file) Because Path functions are not null-terminated, this will attempt to read the file, &quot;/var/www/secret.txt\\0/public.txt&quot;. However, due to the null-byte termination of File functions &quot;secret.txt&quot; will ultimately be read. File/Path checks can be ignored with the following command: $ mix sobelow -i Misc.FilePath"},{"ref":"Sobelow.RCE.html","title":"Sobelow.RCE","type":"module","doc":"Remote Code Execution Remote Code Execution vulnerabilities are a result of untrusted user input being executed or interpreted by the system and may result in complete system compromise. Code Execution checks can be ignored with the following command: $ mix sobelow -i RCE"},{"ref":"Sobelow.RCE.html#details/0","title":"Sobelow.RCE.details/0","type":"function","doc":""},{"ref":"Sobelow.RCE.html#get_vulns/4","title":"Sobelow.RCE.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.RCE.CodeModule.html","title":"Sobelow.RCE.CodeModule","type":"module","doc":""},{"ref":"Sobelow.RCE.CodeModule.html#details/0","title":"Sobelow.RCE.CodeModule.details/0","type":"function","doc":""},{"ref":"Sobelow.RCE.CodeModule.html#parse_def/2","title":"Sobelow.RCE.CodeModule.parse_def/2","type":"function","doc":""},{"ref":"Sobelow.RCE.CodeModule.html#run/2","title":"Sobelow.RCE.CodeModule.run/2","type":"function","doc":""},{"ref":"Sobelow.RCE.EEx.html","title":"Sobelow.RCE.EEx","type":"module","doc":"Insecure EEx evaluation If user input is passed to EEx eval functions, it may result in arbitrary code execution. The root cause of these issues is often directory traversal. EEx checks can be ignored with the following command: $ mix sobelow -i RCE.EEx"},{"ref":"Sobelow.RCE.EEx.html#details/0","title":"Sobelow.RCE.EEx.details/0","type":"function","doc":""},{"ref":"Sobelow.RCE.EEx.html#parse_def/2","title":"Sobelow.RCE.EEx.parse_def/2","type":"function","doc":""},{"ref":"Sobelow.RCE.EEx.html#run/2","title":"Sobelow.RCE.EEx.run/2","type":"function","doc":""},{"ref":"Sobelow.SQL.html","title":"Sobelow.SQL","type":"module","doc":"SQL Injection SQL injection occurs when untrusted input is interpolated directly into a SQL query. In a typical Phoenix application, this would mean using the Ecto.Adapters.SQL.query method and not using the parameterization feature. Read more about SQL injection here: https://www.owasp.org/index.php/SQL_Injection SQL injection checks can be ignored with the following command: $ mix sobelow -i SQL"},{"ref":"Sobelow.SQL.html#details/0","title":"Sobelow.SQL.details/0","type":"function","doc":""},{"ref":"Sobelow.SQL.html#get_vulns/4","title":"Sobelow.SQL.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.SQL.Query.html","title":"Sobelow.SQL.Query","type":"module","doc":""},{"ref":"Sobelow.SQL.Query.html#details/0","title":"Sobelow.SQL.Query.details/0","type":"function","doc":""},{"ref":"Sobelow.SQL.Query.html#parse_repo_query_def/1","title":"Sobelow.SQL.Query.parse_repo_query_def/1","type":"function","doc":""},{"ref":"Sobelow.SQL.Query.html#parse_sql_def/1","title":"Sobelow.SQL.Query.parse_sql_def/1","type":"function","doc":""},{"ref":"Sobelow.SQL.Query.html#run/2","title":"Sobelow.SQL.Query.run/2","type":"function","doc":""},{"ref":"Sobelow.SQL.Stream.html","title":"Sobelow.SQL.Stream","type":"module","doc":""},{"ref":"Sobelow.SQL.Stream.html#details/0","title":"Sobelow.SQL.Stream.details/0","type":"function","doc":""},{"ref":"Sobelow.SQL.Stream.html#parse_sql_def/1","title":"Sobelow.SQL.Stream.parse_sql_def/1","type":"function","doc":""},{"ref":"Sobelow.SQL.Stream.html#run/2","title":"Sobelow.SQL.Stream.run/2","type":"function","doc":""},{"ref":"Sobelow.Traversal.html","title":"Sobelow.Traversal","type":"module","doc":"Path Traversal Path traversal vulnerabilities are a result of interacting with the filesystem using untrusted input. This class of vulnerability may result in file disclosure, code execution, denial of service, and other issues. Read more about Path Traversal here: https://www.owasp.org/index.php/Path_Traversal Path Traversal checks can be ignored with the following command: $ mix sobelow -i Traversal"},{"ref":"Sobelow.Traversal.html#details/0","title":"Sobelow.Traversal.details/0","type":"function","doc":""},{"ref":"Sobelow.Traversal.html#get_vulns/4","title":"Sobelow.Traversal.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.Traversal.FileModule.html","title":"Sobelow.Traversal.FileModule","type":"module","doc":""},{"ref":"Sobelow.Traversal.FileModule.html#details/0","title":"Sobelow.Traversal.FileModule.details/0","type":"function","doc":""},{"ref":"Sobelow.Traversal.FileModule.html#parse_def/2","title":"Sobelow.Traversal.FileModule.parse_def/2","type":"function","doc":""},{"ref":"Sobelow.Traversal.FileModule.html#parse_second_def/2","title":"Sobelow.Traversal.FileModule.parse_second_def/2","type":"function","doc":""},{"ref":"Sobelow.Traversal.FileModule.html#run/2","title":"Sobelow.Traversal.FileModule.run/2","type":"function","doc":""},{"ref":"Sobelow.Traversal.SendDownload.html","title":"Sobelow.Traversal.SendDownload","type":"module","doc":""},{"ref":"Sobelow.Traversal.SendDownload.html#details/0","title":"Sobelow.Traversal.SendDownload.details/0","type":"function","doc":""},{"ref":"Sobelow.Traversal.SendDownload.html#parse_def/1","title":"Sobelow.Traversal.SendDownload.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.Traversal.SendDownload.html#run/2","title":"Sobelow.Traversal.SendDownload.run/2","type":"function","doc":""},{"ref":"Sobelow.Traversal.SendFile.html","title":"Sobelow.Traversal.SendFile","type":"module","doc":""},{"ref":"Sobelow.Traversal.SendFile.html#details/0","title":"Sobelow.Traversal.SendFile.details/0","type":"function","doc":""},{"ref":"Sobelow.Traversal.SendFile.html#run/2","title":"Sobelow.Traversal.SendFile.run/2","type":"function","doc":""},{"ref":"Sobelow.Vuln.html","title":"Sobelow.Vuln","type":"module","doc":"Known Vulnerable Dependencies An application with known vulnerabilities is more easily subjected to automated or targeted attacks. Known Vulnerable checks can be ignored with the following command: $ mix sobelow -i Vuln"},{"ref":"Sobelow.Vuln.html#details/0","title":"Sobelow.Vuln.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.html#get_vulns/1","title":"Sobelow.Vuln.get_vulns/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.html#print_finding/6","title":"Sobelow.Vuln.print_finding/6","type":"function","doc":""},{"ref":"Sobelow.Vuln.Coherence.html","title":"Sobelow.Vuln.Coherence","type":"module","doc":""},{"ref":"Sobelow.Vuln.Coherence.html#details/0","title":"Sobelow.Vuln.Coherence.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.Coherence.html#run/1","title":"Sobelow.Vuln.Coherence.run/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.CookieRCE.html","title":"Sobelow.Vuln.CookieRCE","type":"module","doc":""},{"ref":"Sobelow.Vuln.CookieRCE.html#details/0","title":"Sobelow.Vuln.CookieRCE.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.CookieRCE.html#run/1","title":"Sobelow.Vuln.CookieRCE.run/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.Ecto.html","title":"Sobelow.Vuln.Ecto","type":"module","doc":""},{"ref":"Sobelow.Vuln.Ecto.html#details/0","title":"Sobelow.Vuln.Ecto.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.Ecto.html#run/1","title":"Sobelow.Vuln.Ecto.run/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.HeaderInject.html","title":"Sobelow.Vuln.HeaderInject","type":"module","doc":""},{"ref":"Sobelow.Vuln.HeaderInject.html#details/0","title":"Sobelow.Vuln.HeaderInject.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.HeaderInject.html#run/1","title":"Sobelow.Vuln.HeaderInject.run/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.PlugNull.html","title":"Sobelow.Vuln.PlugNull","type":"module","doc":""},{"ref":"Sobelow.Vuln.PlugNull.html#details/0","title":"Sobelow.Vuln.PlugNull.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.PlugNull.html#run/1","title":"Sobelow.Vuln.PlugNull.run/1","type":"function","doc":""},{"ref":"Sobelow.Vuln.Redirect.html","title":"Sobelow.Vuln.Redirect","type":"module","doc":""},{"ref":"Sobelow.Vuln.Redirect.html#details/0","title":"Sobelow.Vuln.Redirect.details/0","type":"function","doc":""},{"ref":"Sobelow.Vuln.Redirect.html#run/1","title":"Sobelow.Vuln.Redirect.run/1","type":"function","doc":""},{"ref":"Sobelow.XSS.html","title":"Sobelow.XSS","type":"module","doc":"Cross-Site Scripting Cross-Site Scripting (XSS) vulnerabilities are a result of rendering untrusted input on a page without proper encoding. XSS may allow an attacker to perform actions on behalf of other users, steal session tokens, or access private data. Read more about XSS here: https://www.owasp.org/index.php/Cross-siteScripting(XSS) XSS checks can be ignored with the following command: $ mix sobelow -i XSS"},{"ref":"Sobelow.XSS.html#details/0","title":"Sobelow.XSS.details/0","type":"function","doc":""},{"ref":"Sobelow.XSS.html#get_template_vulns/1","title":"Sobelow.XSS.get_template_vulns/1","type":"function","doc":""},{"ref":"Sobelow.XSS.html#get_vulns/4","title":"Sobelow.XSS.get_vulns/4","type":"function","doc":""},{"ref":"Sobelow.XSS.ContentType.html","title":"Sobelow.XSS.ContentType","type":"module","doc":"XSS in put_resp_content_type If an attacker is able to set arbitrary content types for an HTTP response containing user input, the attacker is likely to be able to leverage this for cross-site scripting (XSS). For example, consider an endpoint that returns JSON with user input: {&quot;json&quot;: &quot;user_input&quot;} If an attacker can control the content type set in the HTTP response, they can set it to &quot;text/html&quot; and update the JSON to the following in order to cause XSS: {&quot;json&quot;: &quot;&lt;script&gt;alert(document.domain)&lt;/script&gt;&quot;} Content Type checks can be ignored with the following command: $ mix sobelow -i XSS.ContentType"},{"ref":"Sobelow.XSS.ContentType.html#details/0","title":"Sobelow.XSS.ContentType.details/0","type":"function","doc":""},{"ref":"Sobelow.XSS.ContentType.html#parse_def/1","title":"Sobelow.XSS.ContentType.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.XSS.ContentType.html#run/2","title":"Sobelow.XSS.ContentType.run/2","type":"function","doc":""},{"ref":"Sobelow.XSS.HTML.html","title":"Sobelow.XSS.HTML","type":"module","doc":""},{"ref":"Sobelow.XSS.HTML.html#details/0","title":"Sobelow.XSS.HTML.details/0","type":"function","doc":""},{"ref":"Sobelow.XSS.HTML.html#parse_def/1","title":"Sobelow.XSS.HTML.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.XSS.HTML.html#run/2","title":"Sobelow.XSS.HTML.run/2","type":"function","doc":""},{"ref":"Sobelow.XSS.Raw.html","title":"Sobelow.XSS.Raw","type":"module","doc":""},{"ref":"Sobelow.XSS.Raw.html#details/0","title":"Sobelow.XSS.Raw.details/0","type":"function","doc":""},{"ref":"Sobelow.XSS.Raw.html#parse_raw_def/1","title":"Sobelow.XSS.Raw.parse_raw_def/1","type":"function","doc":""},{"ref":"Sobelow.XSS.Raw.html#parse_render_def/1","title":"Sobelow.XSS.Raw.parse_render_def/1","type":"function","doc":""},{"ref":"Sobelow.XSS.Raw.html#run/4","title":"Sobelow.XSS.Raw.run/4","type":"function","doc":""},{"ref":"Sobelow.XSS.SendResp.html","title":"Sobelow.XSS.SendResp","type":"module","doc":""},{"ref":"Sobelow.XSS.SendResp.html#details/0","title":"Sobelow.XSS.SendResp.details/0","type":"function","doc":""},{"ref":"Sobelow.XSS.SendResp.html#parse_def/1","title":"Sobelow.XSS.SendResp.parse_def/1","type":"function","doc":""},{"ref":"Sobelow.XSS.SendResp.html#run/2","title":"Sobelow.XSS.SendResp.run/2","type":"function","doc":""},{"ref":"readme.html","title":"Sobelow","type":"extras","doc":"Sobelow Sobelow is a security-focused static analysis tool for the Phoenix framework. For security researchers, it is a useful tool for getting a quick view of points-of-interest. For project maintainers, it can be used to prevent the introduction of a number of common vulnerabilities. Currently Sobelow detects some types of the following security issues: Insecure configuration Known-vulnerable Dependencies Cross-Site Scripting SQL injection Command injection Code execution Denial of Service Directory traversal Unsafe serialization Potential vulnerabilities are flagged in different colors according to confidence in their insecurity. High confidence is red, medium confidence is yellow, and low confidence is green. A finding is typically marked &quot;low confidence&quot; if it looks like a function could be used insecurely, but it cannot reliably be determined if the function accepts user-supplied input. That is to say, if a finding is marked green, it may be critically insecure, but it will require greater manual validation. Note: This project is in constant development, and additional vulnerabilities will be flagged as time goes on. If you encounter a bug, or would like to request additional features or security checks, please open an issue!"},{"ref":"readme.html#installation","title":"Sobelow - Installation","type":"extras","doc":"To use Sobelow, you can add it to your application&#39;s dependencies. def deps do [ {:sobelow, &quot;~&gt; 0.8&quot;, only: :dev} ] end You can also install Sobelow globally by executing the following from the command line: $ mix archive.install hex sobelow To install from the master branch, rather than the latest release, the following command can be used: $ mix archive.install github nccgroup/sobelow"},{"ref":"readme.html#use","title":"Sobelow - Use","type":"extras","doc":"The simplest way to scan a Phoenix project is to run the following from the project root: $ mix sobelow"},{"ref":"readme.html#options","title":"Sobelow - Options","type":"extras","doc":"Note: Any path arguments should be absolute paths, or relative to the application root. --root or -r - Specify the application root directory. Accepts a path argument, e.g. ../my_project. --verbose or -v - Print code snippets and additional finding details. --ignore or -i - Ignore given finding types. Accepts a comma-separated list of module names, e.g. XSS.Raw,Traversal. --ignore-files - Ignore files. Accepts a comma-separated list of file names, e.g. config/prod.exs. --details or -d - Get finding-type details. Accepts a single module name, e.g. Config.CSRF. --all-details - Get details of all finding-types. --private - Skip update checks. --router - Specify router location. This only needs to be used if the router location is non-standard. Accepts a path argument, e.g. my/strange/router.ex. --exit - Return non-zero exit status at or above a confidence threshold of low (default), medium, or high. --threshold - Return findings at or above a confidence level of low (default), medium, or high. --format or -f - Specify findings output format. Accepts a format, e.g. txt or json. Note that options such as --verbose will not work with the json format. All json formatted findings contain a type, file, and line key. Other keys may vary. --quiet - Return a single line indicating number of findings. Otherwise, return no output if there are no findings. --compact - Minimal, single-line findings. --save-config - Generates a configuration file based on command line options. See Configuration Files for more information. --config - Run Sobelow with configuration file. See Configuration Files for more information. --mark-skip-all - Mark all displayed findings as skippable. --clear-skip - Clear configuration created by --mark-skip-all. --skip - Ignore findings that have been marked for skipping. See False Positives for more information."},{"ref":"readme.html#configuration-files","title":"Sobelow - Configuration Files","type":"extras","doc":"Sobelow allows users to save frequently used options in a configuration file. For example, if you find yourself constantly running: $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low You can use the --save-config flag to create your .sobelow-conf config file: $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low --save-config This command will create the .sobelow-conf file at the root of your application. You can edit this file directly to make changes. You can also run the command without any options: $ mix sobelow --save-config when you first start out using this package - the generated configuration file will be populated with the default values for each option. (This helps in quickly incorporating this package into a pre-existing codebase.) Now if you want to run Sobelow with the saved configuration, you can run Sobelow with the --config flag. $ mix sobelow --config"},{"ref":"readme.html#false-positives","title":"Sobelow - False Positives","type":"extras","doc":"Sobelow favors over-reporting versus under-reporting. As such, you may find a number of false positives in a typical scan. These findings may be individually ignored by adding a # sobelow_skip comment, along with a list of modules, before the function definition. # sobelow_skip [&quot;Traversal&quot;] def vuln_func(...) do ... end When integrating Sobelow into a new project, there can be a large number of false positives. To mark all printed findings as false positives, run sobelow with the --mark-skip-all flag. Once you have tagged the appropriate findings, run Sobelow with the --skip flag. $ mix sobelow --skip While # sobelow_skip comments can only mark function-level findings (and so cannot be used to skip configuration issues), the --mark-skip-all flag can be used to skip any finding type."},{"ref":"readme.html#modules","title":"Sobelow - Modules","type":"extras","doc":"Findings categories are broken up into modules. These modules can then be used to either ignore classes of findings (via the ignore and skip options) or to get vulnerability details (via the details option). This list, and other helpful information, can be found on the command line: $ mix help sobelow"},{"ref":"readme.html#updates","title":"Sobelow - Updates","type":"extras","doc":"When scanning a project, Sobelow will occasionally check for updates, and will print an alert if a new version is available. Sobelow keeps track of the last update-check by creating a .sobelow file in the root of the scanned project. If this functionality is not desired, the --private flag can be used with the scan."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-10-6","title":"Changelog - v0.10.6","type":"extras","doc":"Bug fixes Handle nil config case"},{"ref":"changelog.html#v0-10-5","title":"Changelog - v0.10.5","type":"extras","doc":"Misc Update code to clean up deprecation warnings"},{"ref":"changelog.html#v0-10-4","title":"Changelog - v0.10.4","type":"extras","doc":"Enhancements Sobelow is now smarter about cross-site websocket hijacking Update URL for CSRF description"},{"ref":"changelog.html#v0-10-3","title":"Changelog - v0.10.3","type":"extras","doc":"Bug fixes Fix directory structure issue in umbrella applications Handle function capture edge cases"},{"ref":"changelog.html#v0-10-2","title":"Changelog - v0.10.2","type":"extras","doc":"Bug fixes Fix a format error in JSON output encoding"},{"ref":"changelog.html#v0-10-1","title":"Changelog - v0.10.1","type":"extras","doc":"Bug fixes Sobelow will use &quot;.sobelow-skips&quot; instead of &quot;.sobelow&quot; in your root directory for --mark-skip-all"},{"ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras","doc":"Enhancements Sobelow now uses &quot;~/.sobelow/sobelow-vsn-check&quot; for update checks The &quot;.sobelow&quot; file in your project root is for --mark-skip-all only"},{"ref":"changelog.html#v0-9-3","title":"Changelog - v0.9.3","type":"extras","doc":"Enhancements Improved checks for all aliased functions Bug Fixes JSON output for Raw findings is now properly normalized send_download correctly flags aliased function calls send_download now correctly flags piped functions"},{"ref":"changelog.html#v0-9-2","title":"Changelog - v0.9.2","type":"extras","doc":"Bug Fixes Fix error that resulted from redefining imported functions"},{"ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras","doc":"Bug Fixes Revert umbrella app recursion"},{"ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras","doc":"Enhancements Add --mark-skip-all and --clear-skip flags New CSRF via action reuse checks Sobelow can now be run in umbrella apps Bug Fixes Fix an error when printing some kinds of variables"},{"ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras","doc":"Enhancements Improve output consistency All JSON findings contain type, file, and line keys &quot;Line&quot; output now refers directly to the vulnerable line Default output headers have been normalized Note: If you depend on the structure of the output, this may be a breaking change. More information can be found at https://sobelow.io."},{"ref":"changelog.html#v0-7-8","title":"Changelog - v0.7.8","type":"extras","doc":"Enhancements Add --threshold flag Add module names to finding output Deprecations File/Path check has been deprecated Bug Fixes Fix inaccurate CSRF details"},{"ref":"changelog.html#v0-7-7","title":"Changelog - v0.7.7","type":"extras","doc":"Enhancements Add check for insecure websocket settings Bug Fixes Accept module attributes for application name"},{"ref":"changelog.html#v0-7-6","title":"Changelog - v0.7.6","type":"extras","doc":"Bug Fixes Fix issue that suppressed output options when config files were in use"},{"ref":"changelog.html#v0-7-5","title":"Changelog - v0.7.5","type":"extras","doc":"Misc Sobelow will now only halt when --exit flag is used"},{"ref":"changelog.html#v0-7-4","title":"Changelog - v0.7.4","type":"extras","doc":"Bug Fixes Log hardcoded secrets for txt output"},{"ref":"changelog.html#v0-7-3","title":"Changelog - v0.7.3","type":"extras","doc":"Misc Tweaks to --out flag."},{"ref":"changelog.html#v0-7-2","title":"Changelog - v0.7.2","type":"extras","doc":"Enhancements Add router path to config findings Add --out flag for writing to file"},{"ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras","doc":"Enhancements Improved handling of JSON format Additional checks for File functions"},{"ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras","doc":"Enhancements Improved handling of vulnerabilities within templates. Bug Fixes Sobelow no longer incorrectly flags :binary send_download functions."},{"ref":"changelog.html#v0-6-9","title":"Changelog - v0.6.9","type":"extras","doc":"Enhancements Improve template parsing and validation. Support multiple routers, and improve route discovery. Misc. Update language for missing directory."},{"ref":"changelog.html#v0-6-8","title":"Changelog - v0.6.8","type":"extras","doc":"Bug Fixes Fix bug in the handling of certain piped functions. Revert not/in update that broke Elixir 1.4 compatibility."},{"ref":"changelog.html#v0-6-7","title":"Changelog - v0.6.7","type":"extras","doc":"Enhancements Remove banner print from JSON format. Bug Fixes Fix error that occurred with certain function names in JSON format."},{"ref":"changelog.html#v0-6-6","title":"Changelog - v0.6.6","type":"extras","doc":"Enhancements Add check for directory traversal via send_download Add check for missing Content-Security-Policy Check additional XSS vectors"},{"ref":"changelog.html#v0-6-5","title":"Changelog - v0.6.5","type":"extras","doc":"Bug Fixes Allow RCE module to be appropriately ignored."},{"ref":"changelog.html#v0-6-4","title":"Changelog - v0.6.4","type":"extras","doc":"Enhancements Set timeout for version check."},{"ref":"changelog.html#v0-6-3","title":"Changelog - v0.6.3","type":"extras","doc":"Enhancements Add RCE module to check for code execution via Code and EEx. Deprecations The --with-code flag has been changed to --verbose. The --with-code flag will continue to work as expected until v1.0.0, but will print a warning message."}]